-- by modelleicher
-- www.schwabenmodding.bplaced.net
-- LUA fuer die komplette Animation einer Vorderachse beim MB-Trac

tracFrontAxle = {};

function tracFrontAxle.prerequisitesPresent(specializations)
    return true;
end;

function tracFrontAxle:load(xmlFile)
	self.zyl = {}; -- Zylinder
	self.zyl.leftZyl = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Lenkzylinder#linksZylIndex"));
	self.zyl.leftStempel =	Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Lenkzylinder#linksStempelIndex"));
	self.zyl.rightZyl = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Lenkzylinder#rechtsZylIndex"));
	self.zyl.rightStempel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Lenkzylinder#rechtsStempelIndex"));
	
	self.sst = {}; -- Spurstange
	self.sst.sstIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Spurstange#index"));
	self.sst.scaleRefPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Spurstange#scaleRefPunkt"));
	self.sst.dirRefPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.tracFrontAchse.Spurstange#directionRefPunkt"));
	self.sst.doScaleBool = Utils.getNoNil(getXMLBool(xmlFile, "vehicle.tracFrontAchse.Spurstange#doScaleBool"), true);
	if self.sst.doScaleBool == true then
		ax, ay, az = getWorldTranslation(self.sst.sstIndex);
		bx, by, bz = getWorldTranslation(self.sst.scaleRefPoint);
		self.sst.scaleDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);	
	end;
end;
function tracFrontAxle:delete()
end;
function tracFrontAxle:mouseEvent(posX, posY, isDown, isUp, button)
end;
function tracFrontAxle:keyEvent(unicode, sym, modifier, isDown)
end;

function tracFrontAxle:update(dt)
	if self:getIsActive() then
		-- Direction des linken Zylinders
		if self.zyl.leftZyl ~= nil and self.zyl.rightZyl ~= nil then
			local ax, ay, az = getWorldTranslation(self.zyl.leftZyl);
			local bx, by, bz = getWorldTranslation(self.zyl.leftStempel);
			x, y, z = worldDirectionToLocal(getParent(self.zyl.leftZyl), bx-ax, by-ay, bz-az);
			setDirection(self.zyl.leftZyl, x, y, z, 0, 0, 1);
			local ax2, ay2, az2 = getWorldTranslation(self.zyl.leftStempel);
			local bx2, by2, bz2 = getWorldTranslation(self.zyl.leftZyl);
			x2, y2, z2 = worldDirectionToLocal(getParent(self.zyl.leftStempel), bx2-ax2, by2-ay2, bz2-az2);
			setDirection(self.zyl.leftStempel, x2, y2, z2, 0, 0, 1);	
			-- Direction des rechten Zylinders
			local ax3, ay3, az3 = getWorldTranslation(self.zyl.rightZyl);
			local bx3, by3, bz3 = getWorldTranslation(self.zyl.rightStempel);
			x3, y3, z3 = worldDirectionToLocal(getParent(self.zyl.rightZyl), bx3-ax3, by3-ay3, bz3-az3);
			setDirection(self.zyl.rightZyl, x3, y3, z3, 0, 0, 1);
			local ax4, ay4, az4 = getWorldTranslation(self.zyl.rightStempel);
			local bx4, by4, bz4 = getWorldTranslation(self.zyl.rightZyl);
			x4, y4, z4 = worldDirectionToLocal(getParent(self.zyl.rightStempel), bx4-ax4, by4-ay4, bz4-az4);
			setDirection(self.zyl.rightStempel, x4, y4, z4, 0, 0, 1);					
		end;
		
		-- Animation der Spurstange
		if self.sst.sstIndex ~= nil then
			local ax, ay, az = getWorldTranslation(self.sst.sstIndex);
			local bx, by, bz = getWorldTranslation(self.sst.dirRefPoint);
			x, y, z = worldDirectionToLocal(getParent(self.sst.sstIndex), bx-ax, by-ay, bz-az);
			setDirection(self.sst.sstIndex, x, y, z, 0, 0, 1);		
			if self.sst.doScaleBool == true then
				local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
				local scaleX, scaleY, scaleZ = getScale(self.sst.sstIndex);
				local setScaleWert = scaleZ * (distance / self.sst.scaleDistance);
				setScale(self.sst.sstIndex, 1, 1, setScaleWert);
			end;
		end;
	end;
end;

function tracFrontAxle:draw()	
end;
